%def_enable static
%def_disable debug
%def_enable apps
%def_enable openmp
%def_without unicap
%def_with swig
%def_with python
%def_with xine
%def_without octave
%def_without gstreamer
%def_with ffmpeg
%def_with 1394libs
%def_with v4l
%def_with gtk
%def_with gthread
%def_without carbon
%def_without imageio
%def_without quicktime
%def_with pic
#----------------------------------------------------------------------
%define set_without() %{expand:%%force_without %{1}} %{expand:%%undefine _with_%{1}}

%{?_with_ffmpeg:%set_without gstreamer}
%{?_with_ffmpeg:%set_without quicktime}
%{?_with_xine:%set_without quicktime}
%{?_with_1394libs:%set_without quicktime}
%{?_with_v4l:%set_without quicktime}

%define bname opencv
%define Name OpenCV
Name: lib%{bname}3
Version: 1.2.1
%define trunk 20090728
Release: alt1.svn%trunk
Provides: lib%bname = %version-%release
Summary:  Intel(R) Open Source Computer Vision Library
License: Distributable
Group: System/Libraries
URL: http://%{bname}library.sourceforge.net/
Source: %bname-%version.tar
Packager: Eugeny A. Rostovtsev (REAL) <real at altlinux.org>

BuildRequires: gcc-c++
BuildRequires: gcc-c++ libjasper-devel libjpeg-devel libtiff-devel
#BuildRequires: openexr-devel libpng-devel
BuildRequires: libpng-devel
%{?_enable_openmp:BuildRequires: libgomp-devel}
%{?_with_unicap:BuildRequires: libunicap-devel}
%{?_with_ffmpeg:BuildRequires: libavformat-devel libswscale-devel}
%{?_with_gstreamer:BuildRequires: gstreamer-devel}
%{?_with_gtk:BuildRequires: libgtk+2-devel}
%{?_with_xine:BuildRequires: libxine-devel}
%{?_with_python:BuildRequires: python-devel}
%{?_with_octave:BuildRequires: octave-devel}
%{?_with_swig:BuildRequires: swig}
%{?_with_1394libs:BuildRequires: libdc1394-devel}

%description
%Name means Intel(R) Open Source Computer Vision Library. It is a
collection of C functions and a few C++ classes that implement many
popular Image Processing and Computer Vision algorithms.
%Name provides cross-platform middle-to-high level API that includes
about 300 C functions and a few C++ classes. Also there are constantly
improving Python bindings to %Name.


%package devel
Group: Development/C++
Summary: Development files for %name
Requires: %name = %version-%release
Provides: lib%bname-devel = %version-%release
Conflicts: lib%bname-devel < %version-%release
Obsoletes: lib%bname-devel < %version-%release

%description devel
%Name means Intel(R) Open Source Computer Vision Library. It is a
collection of C functions and a few C++ classes that implement many
popular Image Processing and Computer Vision algorithms.
%Name provides cross-platform middle-to-high level API that includes
about 300 C functions and a few C++ classes. Also there are constantly
improving Python bindings to %Name.

This package contains header files and documentation needed to develop
applications with %name.


%if_enabled static
%package devel-static
Summary: Static %name
Group: Development/C++
Requires: %name-devel = %version-%release
Provides: lib%bname-devel-static = %version-%release
Conflicts: lib%bname-devel-static < %version-%release
Obsoletes: lib%bname-devel-static < %version-%release

%description devel-static
%Name means Intel(R) Open Source Computer Vision Library. It is a
collection of C functions and a few C++ classes that implement many
popular Image Processing and Computer Vision algorithms.
%Name provides cross-platform middle-to-high level API that includes
about 300 C functions and a few C++ classes. Also there are constantly
improving Python bindings to %Name.

This package contains static library to develop applications with
%name.
%endif


%package doc
Summary: %name documentation
Group: Development/Documentation
BuildArch: noarch
Provides: %bname-doc = %version-%release

%description doc
%Name means Intel(R) Open Source Computer Vision Library. It is a
collection of C functions and a few C++ classes that implement many
popular Image Processing and Computer Vision algorithms.
%Name provides cross-platform middle-to-high level API that includes
about 300 C functions and a few C++ classes. Also there are constantly
improving Python bindings to %Name.

This package contains API Reference for develop with %name.


%package utils
Group: Video
Summary: %Name utils
Requires: %name-utils-data = %version-%release
Provides: lib%bname-utils = %version-%release
Conflicts: lib%bname-utils < %version-%release
Obsoletes: lib%bname-utils < %version-%release

%description utils
%Name means Intel(R) Open Source Computer Vision Library. It is a
collection of C functions and a few C++ classes that implement many
popular Image Processing and Computer Vision algorithms.
%Name provides cross-platform middle-to-high level API that includes
about 300 C functions and a few C++ classes. Also there are constantly
improving Python bindings to %Name.

This package contains %Name demo applications.

%package utils-data
Group: Video
Summary: %Name utils data
BuildArch: noarch
Requires: %name-utils = %version-%release
Provides: lib%bname-utils-data = %version-%release
Conflicts: lib%bname-utils < %version-%release
Obsoletes: lib%bname-utils < %version-%release

%description utils-data
%Name means Intel(R) Open Source Computer Vision Library. It is a
collection of C functions and a few C++ classes that implement many
popular Image Processing and Computer Vision algorithms.
%Name provides cross-platform middle-to-high level API that includes
about 300 C functions and a few C++ classes. Also there are constantly
improving Python bindings to %Name.

This package contains %Name demo applications data.


%package -n python-module-%{bname}3
Group: Development/Python
Summary: Python modules for %Name
Requires: %name-devel = %version-%release
Provides: python-module-%bname = %version-%release
Conflicts: python-module-%bname < %version-%release
Obsoletes: python-module-%bname < %version-%release

%description -n python-module-%{bname}3
%Name means Intel(R) Open Source Computer Vision Library. It is a
collection of C functions and a few C++ classes that implement many
popular Image Processing and Computer Vision algorithms.
%Name provides cross-platform middle-to-high level API that includes
about 300 C functions and a few C++ classes. Also there are constantly
improving Python bindings to %Name.

This package contains an extension module for python that provides a
Python language mapping for the %Name.


%prep
%setup
for i in IlmImf Iex Half; do
	rm -f 3rdparty/lib/$i.lib
done


%build
%define _optlevel 3
#add_optflags -I%_includedir/OpenEXR
%autoreconf
%configure \
    --enable-shared \
    --disable-sse2 \
    %{subst_enable static} \
    %{subst_enable debug} \
    %{subst_enable apps} \
    %{subst_enable openmp} \
    %{subst_with swig} \
    %{subst_with python} \
    %{subst_with xine} \
    %{subst_with ffmpeg} \
    %{subst_with octave} \
    %{subst_with gstreamer} \
    %{subst_with 1394libs} \
    %{subst_with v4l} \
    %{subst_with quicktime} \
    %{subst_with gtk} \
    %{subst_with gthread} \
    %{subst_with unicap} \
    %{subst_with imageio} \
    %{subst_with pic}
#make_build
%make


%install
%make_install \
    DESTDIR=%buildroot \
    opencvdocdir=%_docdir/%name-devel-%version \
    csamplesdir=%_docdir/%name-devel-%version/samples/c \
    pysamplesdir=%_docdir/%name-devel-%version/samples/python \
    install
bzip2 ChangeLog


%files
%doc AUTHORS COPYING THANKS TODO ChangeLog.*
%_libdir/*.so.*


%files devel
%_libdir/*.so
%_includedir/*
%_pkgconfigdir/*


%if_enabled static
%files devel-static
%_libdir/*.a
%endif


%files doc
%_docdir/%name-devel-%version


%files utils
%_bindir/*

%files utils-data
%_datadir/%bname


%files -n python-module-%{bname}3
%python_sitelibdir/*


%changelog
* Tue Jul 28 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 1.2.1-alt1.svn20090728
- Version 1.2.1

* Fri Jul 03 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 1.1-alt2.svn20090630
- Replaced demo data files into separate package
- Added explicit conflict with old utils package

* Wed Jul 01 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 1.1-alt1.svn20090630
- New snapshot
- Soname changed

* Mon Feb 23 2009 Led <led@altlinux.ru> 1.1-alt0.1
- 1.1pre1
- enabled openmp

* Sun Feb 22 2009 Led <led@altlinux.ru> 1.0.0-alt2
- Added libswscale support to avoid the deprecated img_convert
- updated BuildRequires
- fixed Group

* Sun Mar 16 2008 Led <led@altlinux.ru> 1.0.0-alt1
- initial build
